/* ex: set ro ft=c:
 * !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
 *
 * This file is generated automatically from './src/pmc/p6invocation.pmc'
 * by ../../../../../usr/lib64/parrot/3.6.0/tools/build/pmc2c.pl.
 *
 * Any changes made here will be lost!
 *
 */

/* HEADERIZER HFILE: none */
/* HEADERIZER STOP */

#define PARROT_IN_EXTENSION
#define CONST_STRING(i, s) Parrot_str_new_constant((i), s)
#define CONST_STRING_GEN(i, s) Parrot_str_new_constant((i), s)
#include "parrot/parrot.h"
#include "parrot/extend.h"
#include "parrot/dynext.h"
#include "pmc_fixedintegerarray.h"
#include "pmc_p6invocation.h"
#include "pmc_default.h"
#include "pmc_continuation.h"
#include "pmc_callcontext.h"
/*
$Id$
Copyright (C) 2009-2010, The Perl Foundation.

=head1 NAME

src/pmc/P6Invocation.pmc - PMC representing a current invocation

=head1 DESCRIPTION

When we invoke a method in Perl 6, we need to keep the list of candidates
available for callwith, callsame, nextwith, nextsame etc. This PMC is what
gets stuck into the lex pad to represent the the candidate list.

=head2 Methods

=cut

*/

#include "parrot/parrot.h"
#include "pmc_perl6multisub.h"
#include "../binder/bind.h"


/* Selects whether we're doing a real dispatch or just a test to see if
 * we could dispatch. */
#define P6I_MODE_DISPATCH 0
#define P6I_MODE_CHECK    1


/* Flag on the PMC to say whether we're in quiet failure mode (if set)
 * or exception mode if we are unable to dispatch. */
#define PObj_P6I_FAILURE_MODE_FLAG PObj_private0_FLAG


/* Declaration; definition of this is in p6opaque.pmc. */
PMC *look_for_method(PARROT_INTERP, PMC *search_list, INTVAL *start_pos, STRING *name);

/* Another declaration; this one is defined in perl6multisub.pmc. */
PMC *get_all_candidates_with_cur_args(PARROT_INTERP, PMC *self);

static STRING *perl6_str;
static STRING *deferral_fail_str;
static STRING *CANDIDATE_LIST_str;

/* This does the grunt work of working out what the next candidate is. Takes
 * account of us maybe needing to look into multi variants and all that lot. */
static PMC *get_next_candidate(PARROT_INTERP, PMC *SELF, int check_only,
        INTVAL *is_multi_dispatch, PMC **guilty_multi) {
    PMC    *candidates, *current, *search_list;
    STRING *name;
    INTVAL  position, resume_point;

    /* Get candidates and position. */
    GETATTR_P6Invocation_candidate_list(interp, SELF, candidates);
    GETATTR_P6Invocation_position(interp, SELF, position);

    /* Make sure we're not past the end of the candidate list. */
  check_and_continue_search:
    if (PMC_IS_NULL(candidates) || position >= VTABLE_elements(interp, candidates)) {
        /* Past the end; see if we've got a way to resume the search. */
        GETATTR_P6Invocation_search_list(interp, SELF, search_list);
        GETATTR_P6Invocation_name(interp, SELF, name);
        GETATTR_P6Invocation_resume_point(interp, SELF, resume_point);
        if (!PMC_IS_NULL(search_list) && name) {
            /* We can look for more candidates. Try to do so. */
            PMC *found = look_for_method(interp, search_list, &resume_point, name);
            PARROT_GC_WRITE_BARRIER(interp, SELF);
            SETATTR_P6Invocation_resume_point(interp, SELF, resume_point);
            if (PMC_IS_NULL(found))
                return PMCNULL;

            /* If we get here, we have more. Push this next candidate onto the
             * candidate list, creating it in the process if needed. */
            if (PMC_IS_NULL(candidates)) {
                candidates = pmc_new(interp, enum_class_ResizablePMCArray);
                PARROT_GC_WRITE_BARRIER(interp, SELF);
                SETATTR_P6Invocation_candidate_list(interp, SELF, candidates);
            }
            VTABLE_push_pmc(interp, candidates, found);
        }
        else {
            /* No way; give up. */
            return PMCNULL;
        }
    }

    /* Grab current candidate. */
    current = VTABLE_get_pmc_keyed_int(interp, candidates, position);
    if (VTABLE_isa(interp, current, CONST_STRING(interp, "Perl6MultiSub"))) {
        /* Multi. Ask the multi-dispatcher for all possible variants that we
         * could call with the current argument, unless we have none in
         * which we're just gonna have to leave the multi here in the list.
         * We may also mark the first multi we run into as being "guilty"
         * for the dispatch failure so we can give a better error. */
        if (guilty_multi && PMC_IS_NULL(*guilty_multi))
            *guilty_multi = current;
        if (!PMC_IS_NULL(Parrot_pcc_get_signature(interp, CURRENT_CONTEXT(interp)))) {
            PMC *possibles = get_all_candidates_with_cur_args(interp, current);
            if (VTABLE_elements(interp, possibles) == 0) {
                /* No candidates here; increment the position, and then jump back
                 * to check if we need to find another candidate and try again or
                 * if the list is already containing more things for us to try. */
                position++;
                SETATTR_P6Invocation_position(interp, SELF, position);
                goto check_and_continue_search;
            }

            /* If we get here, we have some possibles; splice them into the candidate
             * list, then continue as normal. This means that deferal will take into
             * account the other multi-variants. Then our current becomes the first
             * of the multi candidates. */
            if (is_multi_dispatch)
                *is_multi_dispatch = 1;
            VTABLE_splice(interp, candidates, possibles, position, 1);
            current = VTABLE_get_pmc_keyed_int(interp, candidates, position);
        }
    }
    else if (VTABLE_isa(interp, current, CONST_STRING(interp, "MultiSub"))) {
        /* Parrot MultiSub. Any possible candidates? (Note: Poking at
         * guts a little here.) */
        PMC * const sig_obj = CONTEXT(interp)->current_sig;
        PMC * const func = Parrot_mmd_sort_manhattan_by_sig_pmc(interp, current, sig_obj);
        if (PMC_IS_NULL(func)) {
            position++;
            SETATTR_P6Invocation_position(interp, SELF, position);
            goto check_and_continue_search;
        }
        else {
            if (is_multi_dispatch)
                *is_multi_dispatch = 1;
            VTABLE_set_pmc_keyed_int(interp, candidates, position, func);
            current = func;
        }
    }

    /* Increment position in candidate list if we're in check mode, and we're done. */
    if (!check_only)
        position++;
    SETATTR_P6Invocation_position(interp, SELF, position);
    return current;
}
static  PMC  * Parrot_P6Invocation_clone(PARROT_INTERP, ARGMOD(PMC *_self));
static  INTVAL  Parrot_P6Invocation_does(PARROT_INTERP, ARGMOD(PMC *_self), STRING *what);
static  INTVAL  Parrot_P6Invocation_get_bool(PARROT_INTERP, ARGMOD(PMC *_self));
static  INTVAL  Parrot_P6Invocation_get_integer(PARROT_INTERP, ARGMOD(PMC *_self));
static  PMC  * Parrot_P6Invocation_get_iter(PARROT_INTERP, ARGMOD(PMC *_self));
static  PMC  * Parrot_P6Invocation_get_pmc(PARROT_INTERP, ARGMOD(PMC *_self));
static  void  Parrot_P6Invocation_init(PARROT_INTERP, ARGMOD(PMC *_self));
static  void  Parrot_P6Invocation_init_pmc(PARROT_INTERP, ARGMOD(PMC *_self), PMC *list);
static  opcode_t  * Parrot_P6Invocation_invoke(PARROT_INTERP, ARGMOD(PMC *_self), void *next);
static  void  Parrot_P6Invocation_mark(PARROT_INTERP, ARGMOD(PMC *_self));
static  PMC  * Parrot_P6Invocation_shift_pmc(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_P6Invocation_nci_get(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_P6Invocation_nci_trim_candidate_list(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_P6Invocation_nci_set_failure_mode(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_P6Invocation_nci_Bool(PARROT_INTERP, ARGMOD(PMC *_self));
static  void  Parrot_P6Invocation_init_orig(PARROT_INTERP, ARGMOD(PMC *_self));
static  void  Parrot_P6Invocation_init_pmc_orig(PARROT_INTERP, ARGMOD(PMC *_self), PMC *list);
static  PMC  * Parrot_P6Invocation_shift_pmc_orig(PARROT_INTERP, ARGMOD(PMC *_self));
PARROT_DYNEXT_EXPORT void    Parrot_P6Invocation_class_init(PARROT_INTERP, int, int);
PARROT_DYNEXT_EXPORT VTABLE* Parrot_P6Invocation_update_vtable(ARGMOD(VTABLE*));
PARROT_DYNEXT_EXPORT VTABLE* Parrot_P6Invocation_get_vtable(PARROT_INTERP);
PARROT_DYNEXT_EXPORT VTABLE* Parrot_P6Invocation_get_vtable_pointer(PARROT_INTERP);
PARROT_DYNEXT_EXPORT void    Parrot_P6Invocation_ro_class_init(PARROT_INTERP, int, int);
PARROT_DYNEXT_EXPORT VTABLE* Parrot_P6Invocation_ro_update_vtable(ARGMOD(VTABLE*));
PARROT_DYNEXT_EXPORT VTABLE* Parrot_P6Invocation_ro_get_vtable(PARROT_INTERP);
PARROT_DYNEXT_EXPORT VTABLE* Parrot_P6Invocation_ro_get_vtable_pointer(PARROT_INTERP);
static  PMC  *
Parrot_P6Invocation_clone(PARROT_INTERP, ARGMOD(PMC *_self))
{

    PMC *first_candidate, *candidate_list, *search_list;
    STRING *name;
    INTVAL position, resume_point;

    PMC *copy = pmc_new(interp, _self->vtable->base_type);
    GETATTR_P6Invocation_first_candidate(interp, _self, first_candidate);
    GETATTR_P6Invocation_candidate_list(interp, _self, candidate_list);
    GETATTR_P6Invocation_position(interp, _self, position);
    GETATTR_P6Invocation_search_list(interp, _self, search_list);
    GETATTR_P6Invocation_name(interp, _self, name);
    GETATTR_P6Invocation_resume_point(interp, _self, resume_point);
    SETATTR_P6Invocation_first_candidate(interp, copy, first_candidate);
    SETATTR_P6Invocation_candidate_list(interp, copy, candidate_list);
    SETATTR_P6Invocation_position(interp, copy, position);
    SETATTR_P6Invocation_search_list(interp, copy, search_list);
    SETATTR_P6Invocation_name(interp, copy, name);
    SETATTR_P6Invocation_resume_point(interp, copy, resume_point);
    if (PObj_flag_TEST(P6I_FAILURE_MODE, _self))
        PObj_flag_SET(P6I_FAILURE_MODE, copy);
    return copy;
}
static  INTVAL 
Parrot_P6Invocation_does(PARROT_INTERP, ARGMOD(PMC *_self), STRING *what)
{

    if (Parrot_str_equal(interp, what, CONST_STRING(interp, "invokable")))
        return 1;
    else
        return interp->vtables[enum_class_default]->does(interp, _self, what);
}
static  INTVAL 
Parrot_P6Invocation_get_bool(PARROT_INTERP, ARGMOD(PMC *_self))
{

    PMC    *first_candidate, *candidates;
    INTVAL  position;

    /* First, check if we have a first candidate. */
    GETATTR_P6Invocation_first_candidate(interp, _self, first_candidate);
    if (!PMC_IS_NULL(first_candidate))
        return 1;

    /* Get candidates and position, and check if we have more candidates
     * already known about. */
    GETATTR_P6Invocation_candidate_list(interp, _self, candidates);
    GETATTR_P6Invocation_position(interp, _self, position);
    if (!PMC_IS_NULL(candidates) && position < VTABLE_elements(interp, candidates))
        return 1;

    /* If not, then we see if the dispatcher can potentially find more. */
    Parrot_pcc_set_signature(interp, CURRENT_CONTEXT(interp), NULL);
    return !PMC_IS_NULL(get_next_candidate(interp, _self, P6I_MODE_CHECK, NULL, NULL));
}
static  INTVAL 
Parrot_P6Invocation_get_integer(PARROT_INTERP, ARGMOD(PMC *_self))
{

    return VTABLE_get_bool(interp, _self);
}
static  PMC  *
Parrot_P6Invocation_get_iter(PARROT_INTERP, ARGMOD(PMC *_self))
{

    return VTABLE_clone(interp, _self);
}
static  PMC  *
Parrot_P6Invocation_get_pmc(PARROT_INTERP, ARGMOD(PMC *_self))
{

    PMC *first_candidate;
    PMC *clone = VTABLE_clone(interp, _self);
    GETATTR_P6Invocation_first_candidate(interp, clone, first_candidate);
    if (PMC_IS_NULL(first_candidate)) {
        Parrot_pcc_set_signature(interp, CURRENT_CONTEXT(interp), NULL);
        first_candidate = get_next_candidate(interp, clone, P6I_MODE_CHECK, NULL, NULL);
    }
    return first_candidate;
}
static  void 
Parrot_P6Invocation_init(PARROT_INTERP, ARGMOD(PMC *_self))
{
Parrot_P6Invocation_init_orig(interp, _self);
PARROT_GC_WRITE_BARRIER(interp, _self);
}
static  void 
Parrot_P6Invocation_init_pmc(PARROT_INTERP, ARGMOD(PMC *_self), PMC *list)
{
Parrot_P6Invocation_init_pmc_orig(interp, _self, list);
PARROT_GC_WRITE_BARRIER(interp, _self);
}
static  opcode_t  *
Parrot_P6Invocation_invoke(PARROT_INTERP, ARGMOD(PMC *_self), void *next)
{

    STRING   *lexname = CONST_STRING(interp, "__CANDIDATE_LIST__");
    PMC      *lexpad, *first_candidate;
    opcode_t *addr;
    INTVAL    is_multi_dispatch = 0;
    PMC      *guilty_multi      = PMCNULL;

    /* In the straightforward case, we know our first candidate right off the
     * bat; if not, use list. We also nullify first candidate so we hit the
     * candidate list next time we're used. */
    GETATTR_P6Invocation_first_candidate(interp, _self, first_candidate);
    if (PMC_IS_NULL(first_candidate))
        first_candidate = get_next_candidate(interp, _self, P6I_MODE_DISPATCH,
                &is_multi_dispatch, &guilty_multi);
    else
        SETATTR_P6Invocation_first_candidate(interp, _self, PMCNULL);

    /* Invoke it, then fudge ourself into its lexpad. */
    if (PMC_IS_NULL(first_candidate)) {
        PMC *ns;

        /* Oh noes, no candidate. If we aren't in soft-fail mode, then
         * throw an exception with an informative error message. */
        if (!PObj_flag_TEST(P6I_FAILURE_MODE, _self)) {
            STRING *method_name, *type_name, *signatures;
            
            /* Get object type name. */
            PMC *WHAT, *perl_meth;
            PMC *first_cand = PMCNULL;
            PMC *call_sig   = Parrot_pcc_get_signature(interp, CURRENT_CONTEXT(interp));
            PMC *obj        = VTABLE_get_pmc_keyed_int(interp, call_sig, 0);
            PMC *WHAT_meth  = VTABLE_find_method(interp, obj, CONST_STRING(interp, "WHAT"));
            Parrot_ext_call(interp, WHAT_meth, "Pi->P", obj, &WHAT);
            perl_meth       = VTABLE_find_method(interp, WHAT, CONST_STRING(interp, "perl"));
            Parrot_ext_call(interp, perl_meth, "Pi->S", WHAT, &type_name);
            
            /* Get method name. */
            GETATTR_P6Invocation_name(interp, _self, method_name);

            /* If we know the multi most immediately blameable for not having any
             * candidates, get a dump of it's signatures too. */
            if (!PMC_IS_NULL(guilty_multi)) {
                STRING *siggies;
                PMC *dump_meth = VTABLE_find_method(interp, guilty_multi,
                        CONST_STRING(interp, "dump_sorted_candidate_signatures"));
                Parrot_ext_call(interp, dump_meth, "Pi->S", guilty_multi, &siggies);
                Parrot_ex_throw_from_c_args(interp, next, 1,
                    "No candidates found to invoke for method '%Ss' on object of type '%Ss'; available candidates have signatures:\n%Ss",
                    method_name, type_name, siggies);
            }
            else {
                Parrot_ex_throw_from_c_args(interp, next, 1,
                    "No candidates found to invoke for method '%Ss' on object of type '%Ss'",
                    method_name, type_name);
            }
        }

        /* Otherwise, we look up something that when invoked will just give a
         * dispatch failure. */
        ns = Parrot_ns_get_namespace_keyed_str(interp, interp->root_namespace, CONST_STRING(interp, "perl6"));
        first_candidate = VTABLE_get_pmc_keyed_str(interp, ns, CONST_STRING(interp, "!deferal_fail"));
    }
    addr = VTABLE_invoke(interp, first_candidate, next);
    lexpad = Parrot_pcc_get_lex_pad(interp, CURRENT_CONTEXT(interp));
    if (!PMC_IS_NULL(lexpad) && VTABLE_exists_keyed_str(interp, lexpad, lexname))
        VTABLE_set_pmc_keyed_str(interp, lexpad, lexname, _self);
    if (is_multi_dispatch)
        PObj_flag_SET(P6S_ALREADY_CHECKED, CURRENT_CONTEXT(interp));
    return addr;
}
static  void 
Parrot_P6Invocation_mark(PARROT_INTERP, ARGMOD(PMC *_self))
{

    if (PMC_data(_self)) {
        PMC *first_candidate, *candidate_list, *search_list;
        STRING *name;
        GETATTR_P6Invocation_first_candidate(interp, _self, first_candidate);
        GETATTR_P6Invocation_candidate_list(interp, _self, candidate_list);
        GETATTR_P6Invocation_search_list(interp, _self, search_list);
        GETATTR_P6Invocation_name(interp, _self, name);
        if (!PMC_IS_NULL(first_candidate))
            Parrot_gc_mark_PMC_alive(interp, first_candidate);
        if (!PMC_IS_NULL(candidate_list))
            Parrot_gc_mark_PMC_alive(interp, candidate_list);
        if (!PMC_IS_NULL(search_list))
            Parrot_gc_mark_PMC_alive(interp, search_list);
        if (name)
            Parrot_gc_mark_STRING_alive(interp, name);
    }
}
static  PMC  *
Parrot_P6Invocation_shift_pmc(PARROT_INTERP, ARGMOD(PMC *_self))
{
PMC * result;
result = Parrot_P6Invocation_shift_pmc_orig(interp, _self);
PARROT_GC_WRITE_BARRIER(interp, _self);
return result;}
static  void
Parrot_P6Invocation_nci_get(PARROT_INTERP, ARGMOD(PMC *_self))
{
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    { /* BEGIN PARMS SCOPE */

        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "Pi",
            &_self);
    { /* BEGIN PMETHOD BODY */

    PMC *result = VTABLE_shift_pmc(interp, _self);
        {
    /*BEGIN RETURN PMC *result */
    Parrot_pcc_set_call_from_c_args(interp, _call_object,
        "P", (PMC*)result);
    PARROT_GC_WRITE_BARRIER(interp, _self);
    return;
    /*END RETURN PMC *result */
    }


    } /* END PMETHOD BODY */

    PARROT_GC_WRITE_BARRIER(interp, _self);

    } /* END PARAMS SCOPE */
    return;
}
static  void
Parrot_P6Invocation_nci_trim_candidate_list(PARROT_INTERP, ARGMOD(PMC *_self))
{
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    { /* BEGIN PARMS SCOPE */

        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "Pi",
            &_self);
    { /* BEGIN PMETHOD BODY */

    /* Just blank out everything we could use to find another
     * method. */
    SETATTR_P6Invocation_candidate_list(interp, _self, PMCNULL);
    SETATTR_P6Invocation_position(interp, _self, 0);
    SETATTR_P6Invocation_name(interp, _self, NULL);
    SETATTR_P6Invocation_search_list(interp, _self, PMCNULL);
    SETATTR_P6Invocation_resume_point(interp, _self, 0);

    } /* END PMETHOD BODY */

    PARROT_GC_WRITE_BARRIER(interp, _self);

    } /* END PARAMS SCOPE */
    return;
}
static  void
Parrot_P6Invocation_nci_set_failure_mode(PARROT_INTERP, ARGMOD(PMC *_self))
{
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    { /* BEGIN PARMS SCOPE */

        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "Pi",
            &_self);
    { /* BEGIN PMETHOD BODY */

    PObj_flag_SET(P6I_FAILURE_MODE, _self);

    } /* END PMETHOD BODY */

    PARROT_GC_WRITE_BARRIER(interp, _self);

    } /* END PARAMS SCOPE */
    return;
}
static  void
Parrot_P6Invocation_nci_Bool(PARROT_INTERP, ARGMOD(PMC *_self))
{
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    { /* BEGIN PARMS SCOPE */

        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "Pi",
            &_self);
    { /* BEGIN PMETHOD BODY */

    INTVAL result = VTABLE_get_bool(interp, _self);
        {
    /*BEGIN RETURN INTVAL result */
    Parrot_pcc_set_call_from_c_args(interp, _call_object,
        "I", (INTVAL)result);
    PARROT_GC_WRITE_BARRIER(interp, _self);
    return;
    /*END RETURN INTVAL result */
    }


    } /* END PMETHOD BODY */

    PARROT_GC_WRITE_BARRIER(interp, _self);

    } /* END PARAMS SCOPE */
    return;
}
static  void 
Parrot_P6Invocation_init_orig(PARROT_INTERP, ARGMOD(PMC *_self))
{

    PObj_custom_mark_SET(_self);
}
static  void 
Parrot_P6Invocation_init_pmc_orig(PARROT_INTERP, ARGMOD(PMC *_self), PMC *list)
{

    VTABLE_init(interp, _self);
    SETATTR_P6Invocation_candidate_list(interp, _self, list);
}
static  PMC  *
Parrot_P6Invocation_shift_pmc_orig(PARROT_INTERP, ARGMOD(PMC *_self))
{

    /* Result is a clone of ourself. We clone ourself rather than handing
     * back the method so invocations of it that defer will work out. */
    PMC *result = VTABLE_clone(interp, _self);

    /* Now shuffle along one candidate. */
    PMC *first_candidate;
    GETATTR_P6Invocation_first_candidate(interp, _self, first_candidate);
    if (PMC_IS_NULL(first_candidate)) {
        Parrot_pcc_set_signature(interp, CURRENT_CONTEXT(interp), NULL);
        get_next_candidate(interp, _self, P6I_MODE_DISPATCH, NULL, NULL);
    }
    else {
        SETATTR_P6Invocation_first_candidate(interp, _self, PMCNULL);
    }

    return result;
}
#include "pmc_default.h"

PARROT_DYNEXT_EXPORT 
VTABLE *Parrot_P6Invocation_update_vtable(VTABLE *vt) {
    vt->clone = Parrot_P6Invocation_clone;
    vt->does = Parrot_P6Invocation_does;
    vt->get_bool = Parrot_P6Invocation_get_bool;
    vt->get_integer = Parrot_P6Invocation_get_integer;
    vt->get_iter = Parrot_P6Invocation_get_iter;
    vt->get_pmc = Parrot_P6Invocation_get_pmc;
    vt->init = Parrot_P6Invocation_init;
    vt->init_pmc = Parrot_P6Invocation_init_pmc;
    vt->invoke = Parrot_P6Invocation_invoke;
    vt->mark = Parrot_P6Invocation_mark;
    vt->shift_pmc = Parrot_P6Invocation_shift_pmc;
    vt->attr_size = sizeof(Parrot_P6Invocation_attributes);

    return vt;
}


PARROT_DYNEXT_EXPORT 
VTABLE *Parrot_P6Invocation_ro_update_vtable(ARGMOD(VTABLE *vt)) {
    vt->clone = Parrot_P6Invocation_clone;
    vt->does = Parrot_P6Invocation_does;
    vt->get_bool = Parrot_P6Invocation_get_bool;
    vt->get_integer = Parrot_P6Invocation_get_integer;
    vt->get_iter = Parrot_P6Invocation_get_iter;
    vt->get_pmc = Parrot_P6Invocation_get_pmc;
    vt->invoke = Parrot_P6Invocation_invoke;
    vt->mark = Parrot_P6Invocation_mark;
    vt->attr_size = sizeof(Parrot_P6Invocation_attributes);

    return vt;
}

PARROT_DYNEXT_EXPORT 
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
VTABLE* Parrot_P6Invocation_get_vtable(PARROT_INTERP) {
    VTABLE *vt;
    vt = Parrot_default_get_vtable(interp);
    Parrot_P6Invocation_update_vtable(vt);

    return vt;
}

PARROT_DYNEXT_EXPORT 
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
VTABLE* Parrot_P6Invocation_get_vtable_pointer(PARROT_INTERP) {
    STRING * const type_name = Parrot_str_new_constant(interp, "P6Invocation");
    const INTVAL type_num  = Parrot_pmc_get_type_str(interp, type_name);
    return interp->vtables[type_num];
}

PARROT_DYNEXT_EXPORT 
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
VTABLE* Parrot_P6Invocation_ro_get_vtable(PARROT_INTERP) {
    VTABLE *vt;
    vt = Parrot_default_ro_get_vtable(interp);
    Parrot_P6Invocation_ro_update_vtable(vt);

    return vt;
}

PARROT_DYNEXT_EXPORT 
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
PMC* Parrot_P6Invocation_get_mro(PARROT_INTERP, ARGMOD(PMC* mro)) {
    if (PMC_IS_NULL(mro)) {
        mro = Parrot_pmc_new(interp, enum_class_ResizableStringArray);
    }

    VTABLE_unshift_string(interp, mro,
        Parrot_str_new_init(interp, "P6Invocation", 12,
            Parrot_default_encoding_ptr, 0));
    return mro;
}

PARROT_DYNEXT_EXPORT 
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
Hash* Parrot_P6Invocation_get_isa(PARROT_INTERP, ARGIN_NULLOK(Hash* isa)) {
    if (isa == NULL) {
        isa = Parrot_hash_new(interp);
    }
    Parrot_hash_put(interp, isa, (void *)(CONST_STRING_GEN(interp, "P6Invocation")), PMCNULL);
    return isa;
}

static void thispmc_class_init(PARROT_INTERP, int entry)
{
    
        perl6_str          = CONST_STRING(interp, "perl6");
        deferral_fail_str  = CONST_STRING(interp, "!deferal_fail");
        CANDIDATE_LIST_str = CONST_STRING(interp, "__CANDIDATE_LIST__");

}
void
Parrot_P6Invocation_class_init(PARROT_INTERP, int entry, int pass)
{
    static const char attr_defs [] =
        "Ffirst_candidate Fcandidate_list Sname Fsearch_list Iresume_point Iposition ";
    if (pass == 0) {
        VTABLE * const vt  = Parrot_P6Invocation_get_vtable(interp);
        vt->base_type      = -1;
        vt->flags          = 0|VTABLE_HAS_READONLY_FLAG;
        vt->attribute_defs = attr_defs;
        interp->vtables[entry] = vt;

        vt->base_type    = entry;
        vt->whoami       = Parrot_str_new_init(interp, "P6Invocation", 12,
                                       Parrot_ascii_encoding_ptr, PObj_constant_FLAG|PObj_external_FLAG);
        vt->provides_str = Parrot_str_concat(interp, vt->provides_str,
            Parrot_str_new_init(interp, "scalar", 6, Parrot_ascii_encoding_ptr,
            PObj_constant_FLAG|PObj_external_FLAG));

        vt->isa_hash     = Parrot_P6Invocation_get_isa(interp, NULL);
        {
            VTABLE                   *vt_ro;
            vt_ro                 = Parrot_P6Invocation_ro_get_vtable(interp);
            vt_ro->base_type      = -1;
            vt_ro->flags          = 0|VTABLE_IS_READONLY_FLAG;

            vt_ro->attribute_defs = attr_defs;

            vt_ro->base_type           = entry;
            vt_ro->whoami              = vt->whoami;
            vt_ro->provides_str        = vt->provides_str;
            vt->ro_variant_vtable      = vt_ro;
            vt_ro->ro_variant_vtable = vt;
            vt_ro->isa_hash            = vt->isa_hash;
        }

    }
    else { /* pass */
        {
            VTABLE * const vt  = interp->vtables[entry];

            vt->mro = Parrot_P6Invocation_get_mro(interp, PMCNULL);

            if (vt->ro_variant_vtable)
                vt->ro_variant_vtable->mro = vt->mro;
        }

        /* set up MRO and _namespace */
        Parrot_pmc_create_mro(interp, entry);
        {
            STRING * const method_name = CONST_STRING_GEN(interp, "get");
            STRING * const signature   = CONST_STRING_GEN(interp, "->");
            register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_P6Invocation_nci_get),
                method_name, signature);
        }
        {
            STRING * const method_name = CONST_STRING_GEN(interp, "trim_candidate_list");
            STRING * const signature   = CONST_STRING_GEN(interp, "->");
            register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_P6Invocation_nci_trim_candidate_list),
                method_name, signature);
        }
        {
            STRING * const method_name = CONST_STRING_GEN(interp, "set_failure_mode");
            STRING * const signature   = CONST_STRING_GEN(interp, "->");
            register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_P6Invocation_nci_set_failure_mode),
                method_name, signature);
        }
        {
            STRING * const method_name = CONST_STRING_GEN(interp, "Bool");
            STRING * const signature   = CONST_STRING_GEN(interp, "->");
            register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_P6Invocation_nci_Bool),
                method_name, signature);
        }

        /* class_init */
        thispmc_class_init(interp, entry);


        {
        }
    } /* pass */
} /* Parrot_P6Invocation_class_init */
/*
 * This load function will be called to do global (once) setup
 * whatever is needed to get this extension running
 */


PARROT_DYNEXT_EXPORT Parrot_PMC Parrot_lib_p6invocation_load(PARROT_INTERP); /* don't warn */
PARROT_DYNEXT_EXPORT Parrot_PMC Parrot_lib_p6invocation_load(PARROT_INTERP)
{
    Parrot_String whoami;
    Parrot_PMC    pmc;
    Parrot_Int typeP6Invocation;
    int pass;

    /* create a library PMC */
    pmc = Parrot_pmc_new_constant(interp, enum_class_ParrotLibrary);

    /* TODO: stuff some info into this PMC's props */

    /* for all PMCs we want to register: */
    whoami = CONST_STRING_GEN(interp, "P6Invocation");
    typeP6Invocation = Parrot_pmc_register_new_type(interp, whoami);

    /* do class_init code */
    for (pass = 0; pass <= 1; ++pass) {
        Parrot_P6Invocation_class_init(interp, typeP6Invocation, pass);
    }
    return pmc;
}


